# XfreeRDP

`FreeRDP` è l'implementazione libera del protocollo RDP, rilasciato sotto licenza Apache 2.0.

RDP (Remote Desktop Protocol) è un protocollo di rete proprietario sviluppato da Microsoft, che permette la connessione remota da un computer a un altro utilizzando l'interfaccia grafica (GUI) di Windows, usando di default la porta TCP e UDP 3389.

L'applicazione (che usa il protocollo in oggetto) compresa in Microsoft Windows si chiama `Connessione Desktop remoto`.

## Installazione

Su Debian e derivate:

```bash
sudo apt update ; sudo apt install -y freerdp2-x11
```

## Sintassi

```bash
xfreerdp [file] [options] [/v:<server>[:port]]
```

Ecco un esempio:

```bash
xfreerdp /v:[IP_MACCHINA_REMOTA]:[PORTA] /u:[UTENTE] /t:[TITOLO_FINESTRA] /bpp:32 +window-drag +clipboard /cert-ignore /size:1800x1000 /rfx /dynamic-resolution /gfx /encryption-methods:128 /d:[DOMINIO]
```

dove:

`/v`: ip macchina remota : porta (facoltativa);

`/u`: Utente;

`/t`: Titolo della finestra;

`/f`: Fullscreen mode;

`/p`: Password (in chiaro);

`+compression`: (default:off)  Compressione;

`/bpp:32`: Serve a specificare l'intensità del colore per una sessione remota o la profondità di 
colore. 32bit indica la qualità più alta;
+window-drag    Permette il trascinamento dell'intera finestra;

`+clipboard`: Attivare il copia/incolla;

`cert-ignore`: Ignora il certificato;

`/size:1800x1000`: Dimensioni in pixel della finestra;

`/rfx`:    Microsoft RemoteFX è una tecnologia che migliora l'esperienza visiva;

`/dynamic-resolution`: Invia aggiornamenti della risoluzione quando la finestra viene ridimensionata;

`-encryption` (default:on)

`/encryption-methods`: [40] [56] [128]    Selezionare 128bit i dati vengono crittografati utilizzando una chiave di crittografia a 128 bit. Questo tipo di crittografia potrebbe essere incompatibile con alcuni sistemi;

`/drive:<sharename>,<path>`: reindirizza <path> come cartella condivisa <sharename>;

`/d`: Dominio facoltativo

## Collegamenti

- [https://it.wikipedia.org/wiki/Remote_Desktop_Protocol](https://it.wikipedia.org/wiki/Remote_Desktop_Protocol)
- [https://github.com/awakecoding/FreeRDP-Manuals/blob/master/User/FreeRDP-User-Manual.markdown](https://github.com/awakecoding/FreeRDP-Manuals/blob/master/User/FreeRDP-User-Manual.markdown)
- [https://github.com/FreeRDP/FreeRDP/wiki/CommandLineInterface](https://github.com/FreeRDP/FreeRDP/wiki/CommandLineInterface)
- [https://www.freerdp.com/](https://www.freerdp.com/)
